Unit pePrint; { lpr print routines for pe}
{written by Russell Whitaker <russwhit@mind.net>, Feb 2000
 update: new email adr <russ@ashlandhome.net>, Mar 2002
         released under GPL }

interface

procedure Printfile( Title: string );

implementation

uses Printer, peBuffer;
{$define ESC char(27)}
{$define MAXLINES 58}
{$define TAB char(09)}

type
  ptrctrl = array[ 1..4 ] of string( 7 ) value
    ( ESC + 'x' + char(0),                        { draft }
      ESC + 'x' + char(1) + ESC + 'k' + char(0),  { LQ, Roman }
      ESC + 'P',                                  { pica  }
      ESC + 'M' );                                { elite }

procedure Printfile( Title: string );
var
  px: ptrctrl;
  index: integer = 1;

  procedure PrintPage;
  var
    i: integer = 1;
  begin
    writeln( LST, px[3], Title:35 + length(Title) div 2,
                  '':35 - length(Title) div 2,
                  'line ', index:4 );
    writeln( LST, px[4] );
    while(( i <= MAXLINES ) and ( index <= BB_Count )) do
    begin
      writeln( LST, BB_ReadLine( index ));
      if BB_Len( index ) > 96 then
        inc( i, 2 )
      else
        inc( i );
      inc( index );
    end;
  end;

begin
  if BB_Count > 0 then
  begin
    write( LST, px[2] );
    repeat
      PrintPage;
      write( LST, chr(12));
    until index > BB_Count;
    write( LST, px[1], px[3] );    {leave printer in draft, pica mode}
    close( LST );
  end;
end;

end.
