Unit StringShift;
{written by Russ Whitaker, <russ@ashlandhome.net>
 update 7/7/01: new email; rm $X+/- as no longer needed
        4/2/02: released under GPL }

interface

{ s is source string; start is start of hole; siz is width of hole}
procedure StringShiftRight( var s: string; start, siz: integer ); {open hole}
procedure StringShiftLeft( var s: string; start, siz: integer );  {close hole}

implementation

procedure StringShiftRight( var s: string; start, siz: integer );
var
  i : integer;
begin
  if ( length( s ) + siz ) < s.CAPACITY  then
    i := length( s ) + siz
  else
    i := s.CAPACITY;
  SetLength( s, i );
  MoveRight( s[ start ], s[ start + siz ], i - start - siz + 1 );
end;

procedure StringShiftLeft( var s: string; start, siz: integer );
var
  i,j: integer;
begin
  i := start + siz;
  if ( length( s ) >= i ) then
  begin
    MoveLeft( s[ i ], s[ start ], length( s ) - i + 1 );
    SetLength( s, length( s ) - siz );
  end
  else
    SetLength( s, start - 1);
end;

end.
